/*****************************************************************************
Basic stack of strings unit implemented for use in SFV UNIX port

Copyright (C)1998 Alcatraz of Fantasia Sofware

The source code may not be modified or used in any other purpose then 
the compilation of sfv. It is distributed with the sfv package so it can be 
compiled on the desired platform. Any error or comments should be mailed to 

alc@cyberdude.com
*****************************************************************************/
#include <stdlib.h>
#include <string.h>
#include "stack.h"


/*****************************************************************************
stackCreate
*****************************************************************************/
STACKRECORD *stackCreate()
{
  return NULL;
}


/*****************************************************************************
disposeStack
*****************************************************************************/
void stackDispose(STACKRECORD **stack)
{   
  STACKRECORD *tmpStack;
  while(*stack!=NULL)
  {         
    tmpStack=*stack;
    *stack=(*stack)->next;
    free(tmpStack);
  }
}
            
/*****************************************************************************
stackPush
*****************************************************************************/
void stackPush(STACKRECORD **stack, char *theString)
{
  STACKRECORD *tmpItem;
  STACKRECORD *beforeitem=NULL;
  STACKRECORD *floatitem;
  
  if(theString!=NULL)
  {
    tmpItem=malloc(sizeof(STACKRECORD));
    if(tmpItem!=NULL)
    {
			/*	Well use a lame insertion sort to add the strings
			 *	usually quicksort whould do two passed to sort this before 
			 *	optiomization would cancel it out and on a single linked list
			 *	quicksort aint to cool  */
		floatitem=*stack;
		while(floatitem&&strcasecmp(theString,floatitem->data)>0)
		{
			beforeitem=floatitem;
			floatitem=floatitem->next;
		}

		tmpItem->next=floatitem;
		if(!beforeitem)
			*stack=tmpItem;
		else
			beforeitem->next=tmpItem;

      	tmpItem->data=malloc(strlen(theString)+1);
      	strcpy(tmpItem->data,theString);
    }
  }
}

/*****************************************************************************
stackPop
*****************************************************************************/
char *stackPop(STACKRECORD **stack)
{   
  char	  	*tmpPtr=NULL;
  STACKRECORD   *tmpItem;
  
  if(*stack!=NULL)
  {
    tmpItem=*stack;
    *stack=(*stack)->next;
    tmpPtr=tmpItem->data;
    free(tmpItem);
  }
  
  return tmpPtr;
}

/*****************************************************************************
stackDupe
*****************************************************************************/
int stackDupe(STACKRECORD *stack, char *scanForMe)
{  
  int argStrLen=strlen(scanForMe);
  
  if(scanForMe!=NULL)
  {
    while(stack!=NULL)
    {
      	if((argStrLen==strlen(stack->data))&&(memcmp(scanForMe,stack->data,argStrLen)==0))
       		return 1;
      	stack=stack->next;
    }
  }
  return 0;
}

/*****************************************************************************
stackPushDupe
*****************************************************************************/
int stackPushDupe(STACKRECORD **stack, char *theString)
{
  if(!stackDupe(*stack, theString))
  {
    stackPush(stack,theString);
    return 1;
  }
  return 0;
}

/*****************************************************************************
stackIsEmpty
*****************************************************************************/
int stackIsEmpty(STACKRECORD *stack)
{
  return (stack==NULL);
}

/*****************************************************************************
stackAddEnd
*****************************************************************************/
void stackAddEnd(STACKRECORD **stack, char *theString)
{
  STACKRECORD *tmpItem;
  
  if(theString!=NULL)
  {
    if(*stack!=NULL)
    {               
      	tmpItem=*stack;
      	while(tmpItem->next!=NULL) tmpItem=tmpItem->next;
      	tmpItem->next=malloc(sizeof(STACKRECORD));
      	tmpItem=tmpItem->next;
    }else
    {
        *stack=malloc(sizeof(STACKRECORD));
        tmpItem=*stack;
    }
    if(tmpItem!=NULL)
    {
      	tmpItem->next=NULL;
      	tmpItem->data=malloc(strlen(theString));
      	strcpy(tmpItem->data,theString);
      	*stack=tmpItem;
    }
  }
}
